Re: [PATCH v2] Makefile: use -z pack-relative-relocs

[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index]

 



On Fri, Apr 7, 2023 at 11:35 AM Nick Desaulniers
<ndesaulniers@xxxxxxxxxx> wrote:
>
> On Fri, Mar 24, 2023 at 2:22 PM Fangrui Song <maskray@xxxxxxxxxx> wrote:
> >
> > Commit 27f2a4db76e8 ("Makefile: fix GDB warning with CONFIG_RELR")
> > added --use-android-relr-tags to fix a GDB warning
> >
> > BFD: /android0/linux-next/vmlinux: unknown type [0x13] section `.relr.dyn'
> >
> > The GDB warning has been fixed in version 11.2.
> >
> > The DT_ANDROID_RELR tag was deprecated since DT_RELR was standardized.
> > Thus, --use-android-relr-tags should be removed. While making the
> > change, try -z pack-relative-relocs, which is supported since LLD 15.
> > Keep supporting --pack-dyn-relocs=relr as well for older LLD versions.
> >
> > As of today, GNU ld supports the latter option for x86 and powerpc64
> > ports and has no intention to support --pack-dyn-relocs=relr. In the
> > absence of the glibc symbol version GLIBC_ABI_DT_RELR,
> > --pack-dyn-relocs=relr and -z pack-relative-relocs are identical in
> > ld.lld.
> >
> > Link: https://github.com/ClangBuiltLinux/linux/issues/1057
> > Link: https://sourceware.org/git/?p=binutils-gdb.git;a=commit;h=a619b58721f0a03fd91c27670d3e4c2fb0d88f1e
> > Signed-off-by: Fangrui Song <maskray@xxxxxxxxxx>
>
> Thanks v2 looks better. IIUC, this will first try to test+use
> `--pack-dyn-relocs=relr` in preference to `-z pack-relative-relocs`.
> Do we want to reorder the preference, for both the test and actual
> flag used?

Thanks for the comment. The order is deliberate and there is no
obsolescence indication of --pack-dyn-relocs=relr.

GNU ld and newer lld report warnings (instead of errors) for unknown
-z options, and only errors lead to non-zero exit codes.

Therefore, $(call ld-option,--pack-dyn-relocs=relr,-z
pack-relative-relocs) has to place --pack-dyn-relocs=relr first.
scripts/tools-support-relr.sh has to test --pack-dyn-relocs=relr first as well.

> > ---
> >  Makefile                      | 3 ++-
> >  scripts/tools-support-relr.sh | 8 ++++++--
> >  2 files changed, 8 insertions(+), 3 deletions(-)
> > ---
> > Changes from v1:
> > * Keep supporting --pack-dyn-relocs=relr for older ld.lld versions
> >
> > diff --git a/Makefile b/Makefile
> > index a2c310df2145..e23a85476d5d 100644
> > --- a/Makefile
> > +++ b/Makefile
> > @@ -1113,7 +1113,8 @@ LDFLAGS_vmlinux   += -X
> >  endif
> >
> >  ifeq ($(CONFIG_RELR),y)
> > -LDFLAGS_vmlinux        += --pack-dyn-relocs=relr --use-android-relr-tags
> > +# ld.lld before 15 did not support -z pack-relative-relocs.
> > +LDFLAGS_vmlinux        += $(call ld-option,--pack-dyn-relocs=relr,-z pack-relative-relocs)
> >  endif
> >
> >  # We never want expected sections to be placed heuristically by the
> > diff --git a/scripts/tools-support-relr.sh b/scripts/tools-support-relr.sh
> > index cb55878bd5b8..4c121946e517 100755
> > --- a/scripts/tools-support-relr.sh
> > +++ b/scripts/tools-support-relr.sh
> > @@ -7,8 +7,12 @@ trap "rm -f $tmp_file.o $tmp_file $tmp_file.bin" EXIT
> >  cat << "END" | $CC -c -x c - -o $tmp_file.o >/dev/null 2>&1
> >  void *p = &p;
> >  END
> > -$LD $tmp_file.o -shared -Bsymbolic --pack-dyn-relocs=relr \
> > -  --use-android-relr-tags -o $tmp_file
> > +
> > +# ld.lld before 15 did not support -z pack-relative-relocs.
> > +if ! $LD $tmp_file.o -shared -Bsymbolic --pack-dyn-relocs=relr -o $tmp_file 2>/dev/null; then
> > +       $LD $tmp_file.o -shared -Bsymbolic -z pack-relative-relocs -o $tmp_file 2>&1 |
> > +               grep -q pack-relative-relocs && exit 1
> > +fi
> >
> >  # Despite printing an error message, GNU nm still exits with exit code 0 if it
> >  # sees a relr section. So we need to check that nothing is printed to stderr.
> > --
> > 2.40.0.348.gf938b09366-goog
> >
>
>
> --
> Thanks,
> ~Nick Desaulniers



-- 
宋方睿




[Index of Archives]     [Linux&nblp;USB Development]     [Linux Media]     [Video for Linux]     [Linux Audio Users]     [Yosemite Secrets]     [Linux Kernel]     [Linux SCSI]

  Powered by Linux